package com.example.wifi_configuration;

import android.content.Context;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry;

public class WifiConfigurationCallbackPlugin implements FlutterPlugin {

    private static final String CHANNEL_NAME = "example.com/wifi_configuration";
    private MethodChannel channel;

    public static void registerWith(PluginRegistry.Registrar registrar) {
        final WifiConfigurationCallbackPlugin plugin = new WifiConfigurationCallbackPlugin();
        plugin.setupChannel(registrar.messenger(), registrar.context());
    }

    @Override
    public void onAttachedToEngine(FlutterPlugin.FlutterPluginBinding binding) {
        setupChannel(binding.getBinaryMessenger(), binding.getApplicationContext());
    }

    @Override
    public void onDetachedFromEngine(FlutterPlugin.FlutterPluginBinding binding) {
        teardownChannel();
    }

    private void setupChannel(BinaryMessenger messenger, Context context) {
        channel = new MethodChannel(messenger, CHANNEL_NAME);
        WifiConfigurationPlugin handler = new WifiConfigurationPlugin();
        channel.setMethodCallHandler(handler);
    }

    private void teardownChannel() {
        channel.setMethodCallHandler(null);
        channel = null;
    }

}
