package com.example.wifi_configuration.alarm;

import android.app.Service;
import android.content.Intent;
import android.net.wifi.WifiManager;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.Nullable;

import java.util.Objects;

public class AlarmService extends Service {

    private static final int ENABLE_WIFI_ALARM_ID = 579;
    private static final int DISABLE_WIFI_ALARM_ID = 336;
    PreferenceManager preferenceManager;

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        WifiManager wifiManager = (WifiManager) getApplicationContext().getSystemService(WIFI_SERVICE);
        String alarmId = Objects.requireNonNull(intent.getExtras()).getString("alarmId");
        Toast.makeText(getApplicationContext(), "Enter here in service: " + alarmId, Toast.LENGTH_LONG).show();
        assert alarmId != null;
        Log.e("Enter in service: ", "Yeah service");
        if (Integer.parseInt(alarmId) == ENABLE_WIFI_ALARM_ID){
            wifiManager.setWifiEnabled(false);
            Log.e("Wifi  in service: ", "enabled service");
        }else {
            wifiManager.setWifiEnabled(false);
            Log.e("Wifi  in service: ", "Disabled service");

        }

        return START_NOT_STICKY;


    }
}
